#!/usr/bin/env python

from email import message_from_string
from email.generator import Generator
import sys

try:
    from cStringIO import StringIO
except ImportError:
    from StringIO import StringIO

def until_from(f, skip=0):
    number = 0
    while number <= skip:
        l = []
        s = f.readline()
        while s:
            l.append(s)
            s = f.readline()
            if s.startswith("From "):
                number += 1
                break
        else:
            number += 1
            break
    if number > skip:
        return "".join(l)
    else:
        return ""

def as_string(message):

    """
    Return the string representation of 'message', attempting to preserve the
    precise original formatting.
    """

    out = StringIO()
    generator = Generator(out, False, 0) # disable reformatting measures
    generator.flatten(message)
    return out.getvalue()

def decode(part):

    """
    Change the transfer encoding on 'part' and its subparts so that a plain text
    representation may be displayed.
    """

    payload = part.get_payload(decode=True)
    if payload:
        encoding = part.get("Content-Transfer-Encoding")
        if encoding:
            del part["Content-Transfer-Encoding"]
            part["Content-Transfer-Encoding"] = "8bit"
            part.set_payload(payload)
    else:
        for p in part.get_payload():
            decode(p)

# Main program.

if __name__ == "__main__":
    skip = int((sys.argv[1:] or [0])[0])
    message = message_from_string(until_from(sys.stdin, skip))
    decode(message)
    print as_string(message)

# vim: tabstop=4 expandtab shiftwidth=4
